<?xml version="1.0" encoding="utf-8"?>

<!-- Copyright (c) 2007 Chris Povirk -->
<!-- Distributed under the terms of the GNU General Public License v2 -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:tag="urn:X-tags:twofoos.org" xmlns:xi="http://www.w3.org/2001/XInclude" xmlns="http://www.w3.org/1999/xhtml" exclude-result-prefixes="tag #default xi">
<xsl:output method="xml" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" encoding="utf-8" indent="yes" />

  <xsl:template match="/pages">

    <html lang="en" xml:lang="en">
    <head>
      <title>
        <xsl:text>Two 〈Foo〉s Walk into a 〈Bar〉</xsl:text>
      </title>

      <xi:include href="generatormeta.xml" />

      <link rel="stylesheet" type="text/css" href="/stylesheet.css" />

      <link rel="icon" type="image/png" href="/favicon.ico" />

      <link rel="alternate" type="application/atom+xml" title="Two 〈Foo〉s Walk into a 〈Bar〉" href="/feed/" />
    </head>
    <body>

      <xi:include href="h1.xml" />

      <div id="content">
        <h2>Home</h2>

        <h3>Quick Links</h3>
        <ul>
          <li><a href="/content/smartsearch/">SmartSearch</a></li>
          <li><a href="/content/pittlinks/">Pitt Links</a></li>
          <li><a href="/content/wpa_supplicant/">wpa_supplicant for Linux Networking at Pitt</a></li>
          <li><a href="/content/labprinting/">Printing to Lab Printers from Dorms/Home</a></li>
<!--          <li><a href=""></a></li> -->
        </ul>

        <h3>Recent Updates</h3>
        <dl id="recentupdates">
          <xsl:apply-templates select="//update">
            <xsl:sort select="@datetime" order="descending" />
          </xsl:apply-templates>
        </dl>
      </div>

      <div id="sidebar">
        <h2>Site Navigation/Info</h2>

        <!-- TODO would be nice to find a better way to do this here and in content.xslt -->
        <xi:include href="nav.xml" />

        <xi:include href="footer.xml" />
      </div>

    </body>
    </html>

  </xsl:template>

  <xsl:template match="//page//update">
    <xsl:if test="position() &lt;= 10">
      <xsl:variable name="datetime"><xsl:value-of select="@datetime" /></xsl:variable>
      <xsl:variable name="date"><xsl:value-of select="translate(substring($datetime, 0, 11),'-','‐')" /></xsl:variable>

      <xsl:for-each select="ancestor::page">
        <xsl:variable name="href">
          <xsl:text>content/</xsl:text>
          <xsl:value-of select="ancestor::file/@name" />
          <xsl:text>/#update_</xsl:text>
          <xsl:value-of select="$datetime" />
        </xsl:variable>

        <xsl:for-each select="title">
          <dt><a href="{$href}"><xsl:value-of select="." /></a></dt>
        </xsl:for-each>
      </xsl:for-each> 

      <dd>
        <xsl:variable name="updatesummary">
          <xsl:value-of select="." />
        </xsl:variable>

        <xsl:choose>
          <xsl:when test="$updatesummary = 'initial posting'">
            <strong><xsl:text>New </xsl:text></strong>
            (<xsl:value-of select="$date" />)

            <p><xsl:value-of select="ancestor::page/description" /></p>
          </xsl:when>

          <xsl:otherwise>
            <xsl:text>Updated: </xsl:text>
            <xsl:value-of select="$date" />

            <p><xsl:value-of select="$updatesummary" /></p>
          </xsl:otherwise>
        </xsl:choose>
      </dd>
    </xsl:if>
  </xsl:template>
</xsl:stylesheet>
