<?xml version="1.0" encoding="utf-8"?>

<!-- Copyright (c) 2007 Chris Povirk -->
<!-- Distributed under the terms of the GNU General Public License v2 -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:tag="urn:X-tags:twofoos.org" xmlns:xhtml="http://www.w3.org/1999/xhtml" xmlns:xi="http://www.w3.org/2001/XInclude" xmlns="http://www.w3.org/2005/Atom" xmlns:atom="http://www.w3.org/2005/Atom" exclude-result-prefixes="tag xi #default">
<xsl:output method="xml" encoding="utf-8" indent="yes" />

  <xsl:variable name="page" select="$name" />

  <xsl:variable name="pagehref">
    <xsl:value-of select="$basehref" />
    <xsl:text>content/</xsl:text>
    <xsl:value-of select="$page" />
    <xsl:text>/</xsl:text>
  </xsl:variable>

<!-- why do these not work without atom: in front of them? -->
<!-- I was also confused about something else... -->
  <xsl:template match="/atom:feed">
    <xsl:copy select=".">
      <xsl:apply-templates />
    </xsl:copy>
  </xsl:template>

  <!-- TODO merge some of this with tagfeed -->
  <xsl:template match="//atom:link[@rel = 'alternate']">
    <link rel="alternate" type="application/xhtml+xml" hreflang="en" href="{$pagehref}" />
  </xsl:template>

  <xsl:template match="//atom:link[@rel = 'self']">
    <link rel="self" type="application/atom+xml" href="{$pagehref}feed/" />
  </xsl:template>

  <xsl:template match="//atom:entry">
    <!-- TODO pull out this node set somehow, since it's used repeatedly, and similarly in tagfeed -->
    <xsl:for-each select="atom:link[starts-with(@href, $pagehref)]">
      <xsl:copy-of select="ancestor::atom:entry" />
    </xsl:for-each>
  </xsl:template>

  <xsl:template match="/atom:feed/atom:title">
    <title>
      <xsl:value-of select="//atom:link[starts-with(@href, $pagehref)]/ancestor::atom:entry/atom:title[1]" />
      <xsl:text> | </xsl:text>
      <xsl:value-of select="." />
    </title>
  </xsl:template>

  <xsl:template match="/atom:feed/atom:subtitle" />

  <xsl:template match="/atom:feed/atom:updated">
    <updated>
      <xsl:for-each select="//atom:link[starts-with(@href, $pagehref)]/ancestor::atom:entry/atom:updated">
        <xsl:sort select="@datetime" />

        <xsl:if test="position() = last()">
          <xsl:value-of select="." />
        </xsl:if>
      </xsl:for-each>
    </updated>
  </xsl:template>

  <xsl:template match="text()">
    <xsl:value-of select="." />
  </xsl:template>

  <xsl:template match="*">
    <!-- TODO try xsl:copy here and similarly in tagfeed -->
    <xsl:element name="{local-name()}" namespace="http://www.w3.org/2005/Atom">
      <xsl:copy-of select="@*" />
      <xsl:apply-templates />
    </xsl:element>
  </xsl:template>

</xsl:stylesheet>
