<?xml version="1.0" encoding="utf-8"?>

<!-- Copyright (c) 2007 Chris Povirk -->
<!-- Distributed under the terms of the GNU General Public License v2 -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:tag="urn:X-tags:twofoos.org" xmlns:xhtml="http://www.w3.org/1999/xhtml" xmlns:xi="http://www.w3.org/2001/XInclude" xmlns="http://www.w3.org/2005/Atom" xmlns:atom="http://www.w3.org/2005/Atom" exclude-result-prefixes="tag xi #default">
<xsl:output method="xml" encoding="utf-8" indent="yes" />

<!-- why do these not work without atom: in front of them? -->
<!-- I was also confused about something else... -->
  <xsl:template match="/atom:feed">
    <xsl:copy select=".">
      <xsl:apply-templates />
    </xsl:copy>
  </xsl:template>

  <xsl:variable name="taghref">
    <xsl:value-of select="$basehref" />
    <xsl:text>tag/</xsl:text>
    <xsl:value-of select="$tag" />
    <xsl:text>/</xsl:text>
  </xsl:variable>

  <xsl:template match="//atom:link[@rel = 'alternate']">
    <link rel="alternate" type="application/xhtml+xml" hreflang="en" href="{$taghref}" />
  </xsl:template>

  <xsl:template match="//atom:link[@rel = 'self']">
    <link rel="self" type="application/atom+xml" href="{$taghref}feed/" />
  </xsl:template>

  <xsl:template match="//atom:entry">
    <xsl:for-each select="atom:category[@term = $tag]">
      <xsl:copy-of select="ancestor::atom:entry" />
    </xsl:for-each>
  </xsl:template>

  <xsl:template match="/atom:feed/atom:title">
    <title>
      <xsl:value-of select="$tag" />
      <xsl:text> | </xsl:text>
      <xsl:value-of select="." />
    </title>
  </xsl:template>

  <xsl:template match="/atom:feed/atom:subtitle" />

  <xsl:template match="/atom:feed/atom:updated">
    <updated>
      <xsl:for-each select="//atom:category[@term = $tag]/ancestor::atom:entry/atom:updated">
        <xsl:sort select="@datetime" />

        <xsl:if test="position() = last()">
          <xsl:value-of select="." />
        </xsl:if>
      </xsl:for-each>
    </updated>
  </xsl:template>

  <xsl:template match="text()">
    <xsl:value-of select="." />
  </xsl:template>

  <xsl:template match="*">
    <xsl:element name="{local-name()}" namespace="http://www.w3.org/2005/Atom">
      <xsl:copy-of select="@*" />
      <xsl:apply-templates />
    </xsl:element>
  </xsl:template>

</xsl:stylesheet>
