<?xml version="1.0" encoding="utf-8"?>

<!-- Copyright (c) 2007 Chris Povirk -->
<!-- Distributed under the terms of the GNU General Public License v2 -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:tag="urn:X-tags:twofoos.org" xmlns:xi="http://www.w3.org/2001/XInclude" xmlns="http://www.w3.org/1999/xhtml" exclude-result-prefixes="tag #default xi">
<xsl:output method="xml" doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" encoding="utf-8" indent="yes" />

  <xsl:template match="/pages">

    <html lang="en" xml:lang="en">
    <head>
      <title>
        <xsl:value-of select="$tag" />
        <xsl:text> | </xsl:text>
        <xsl:text>Two 〈Foo〉s Walk into a 〈Bar〉</xsl:text>
      </title>

      <xi:include href="generatormeta.xml" />

      <link rel="stylesheet" type="text/css" href="/stylesheet.css" />

      <link rel="alternate" type="application/atom+xml" title="Two 〈Foo〉s Walk into a 〈Bar〉" href="/feed/" />
      <link rel="alternate" type="application/atom+xml" title="Two 〈Foo〉s Walk into a 〈Bar〉 » {$tag}" href="feed/" />
    </head>
    <body>

      <xi:include href="h1.xml" />

      <div id="content">
        <h2><xsl:value-of select="$tag" /></h2>

        <dl>
          <xsl:apply-templates>
            <xsl:sort select="page/title" />
          </xsl:apply-templates>
        </dl>
      </div>

      <div id="sidebar">
        <h2>Site Navigation/Info</h2>

        <!-- TODO would be nice to find a better way to do this here and in content.xslt -->
        <xi:include href="nav.xml" />

        <xi:include href="footer.xml" />
      </div>

    </body>
    </html>

  </xsl:template>

  <xsl:template match="//file">
    <xsl:for-each select="page/tags/*[local-name() = $tag]//ancestor::file">
      <dt>
        <a>
          <xsl:attribute name="href">
            <xsl:text>/content/</xsl:text>
            <xsl:value-of select="@name" />
            <xsl:text>/</xsl:text>
          </xsl:attribute>

          <xsl:value-of select="page/title" />
          <xsl:if test="string(page/subtitle)">
            <xsl:text>: </xsl:text>
            <xsl:value-of select="page/subtitle" />
          </xsl:if>
        </a>
      </dt>
      <dd>
        <xsl:copy-of select="page/description" />
      </dd>
    </xsl:for-each>
  </xsl:template>

</xsl:stylesheet>
